(ns eml-util.core
  (:gen-class)
  (:import [java.io File])
  (:import java.text.ParseException)
  (:import java.text.SimpleDateFormat)
  (:import java.util.Date)
  (:import java.text.DateFormat)
  (:import [javax.mail Session])
  (:import [javax.mail.internet MimeMessage])
  (:import [java.util Properties]
           [javax.mail Session Store])
  (:require [clojure.java.io :as io])           
  (:require [clojure.string :as string])           
  (:refer-clojure :exclude [count])
)
(use '[clojure.string :only(join split)])

;=========================================================================
;
; These next two beauties i just copied.
;
; I am forced to copy this routine as the conjure.contribute has been rearanged
; and I cant locate the libraries. LGU

(defn as-str
  "Like clojure.core/str, but if an argument is a keyword or symbol,
its name will be used instead of its literal representation.

Example:
(str :foo :bar) ;;=> \":foo:bar\"
(as-str :foo :bar) ;;=> \"foobar\"

Note that this does not apply to keywords or symbols nested within
data structures; they will be rendered as with str.

Example:
(str {:foo :bar}) ;;=> \"{:foo :bar}\"
(as-str {:foo :bar}) ;;=> \"{:foo :bar}\" "
  {:deprecated "1.2"}
  ([] "")
  ([x] (if (instance? clojure.lang.Named x)
         (name x)
         (str x)))
  ([x & ys]
     ((fn [^StringBuilder sb more]
        (if more
          (recur (. sb (append (as-str (first more)))) (next more))
          (str sb)))
      (new StringBuilder ^String (as-str x)) ys)))

;=========================================================================
; I am forced to copy this routine as the conjure.contribute has been rearanged
; and I cant locate the libraries. LGU
(defn ^Properties as-properties
  "Convert any seq of pairs to a java.utils.Properties instance.
   Uses as-str to convert both keys and values into strings."
  {:tag Properties}
  [m]
  (let [p (Properties.)]
    (doseq [[k v] m]
      (.setProperty p (as-str k) (as-str v)))
    p))
;=========================================================================
(def session (Session/getDefaultInstance (as-properties [["mail.store.protocol" "imaps"]])))
;=========================================================================
(defn get-message [aFile](with-open [fis (io/input-stream aFile)](bean (MimeMessage. session fis))) )
;=========================================================================
(defn get-sentDate [message] (:sentDate message))  
;=========================================================================
(defn walk-the-directory [dir do-the-walk]
  (doseq [a-file (.listFiles dir)]
    (if (.isDirectory a-file)
      (if (= do-the-walk true)
        (do
          (println (.getName a-file))
          (walk-the-directory a-file do-the-walk)
          )
        )
      (do
       (try
        (def file-extension (last (split (.getName a-file) #"\.")))
        (if (= (string/lower-case file-extension) "eml") 
          (do 
            (def a-counter (inc a-counter))
            (def a-message (get-message a-file))
            (if (not= (.getTime (get-sentDate a-message)) (.lastModified a-file))
              (do 
               (def changed (inc changed))
               (println 
                 (str changed 
                      ":  old date: " (.lastModified a-file) 
                      "  new date: "  (.getTime (get-sentDate a-message)) 
                      "  :"           (.getName a-file) ) )
               (.setLastModified a-file (.getTime (get-sentDate (get-message a-file))))) ) ) ) 
       (catch Exception e)
       ) 
     )
) ) )
;=========================================================================
(defn -main
  "I don't do a whole lot ... yet."
  [& args]
  ;; work around dangerous default behaviour in Clojure
  (alter-var-root #'*read-eval* (constantly false))
  (println "Email utilities (c) 2013 LGu")
  (if (not (first args))
    (do
      (println "usage:   java -jar eml-util.jar [path] [yes | no]")
      (println "example: java -jar eml-util.jar c:\\emails yes")
      (println "yes to walk the directory path, anything else to handle only the given directory")
    )
    (do
  
      (def a-counter 0)
      (def changed 0)

      (walk-the-directory (File. (first args)) (if (= (second args) "yes") true false)  ) 
      (println  (str "Email files checked: " a-counter "   Email files changed: " changed))
    )
  )
)
;=========================================================================
